/* mesh with that loads data in VGA RAM via OpenGL extensions
derived from NeHe samples */
#ifndef __clf_MESH_DEFINED__
#define __clf_MESH_DEFINED__

#include "clf_math.h"

class clf_mesh
{
public:
	// Mesh Data
	int          m_nVertexCount;
	clf_vector3D*     m_pVertices;
	clf_vector3D*     m_pNormals;
	clf_point2D*     m_pTexCoords;
	unsigned int m_nTextureId;

	// Vertex Buffer Object Names
	unsigned int m_nVBOVertices;    // vertices and normals
	unsigned int m_nVBOTexCoords;   // texture coordinates

	clf_vector3D calc_face_norm(int idx1, int idx2, int idx3);
	void build_buffers();
	float get_alpha( unsigned char* imageData, int width, int hight, int nX, int nY ){
		// calculate the pixel adress in the image
		int nPos = ( ( nX % width )  + ( ( nY % hight ) * width ) ) * 4;
		// get the alpha value
		float flA = (float) imageData[ nPos + 3];
		return flA;
	}

public:
	clf_mesh();
	~clf_mesh();

	bool load_height_map( char* file_name, float height_scale, float length_scale, float resolution );
	void render();
};

#endif // __clf_MESH_DEFINED__
